import java.util.*;

// Un agenda est uen collection de rendez-vous.
// La classe RendezVous est une classe abstraite ce qui permet d'ajouter
//  des rdv de classes diffrentes du moment que ces classes hritent de la 
//  classe abstraite
//
public class Agenda
{
    // Collection polymorphe de rendez-vous
    public ArrayList<RendezVous> rdvs;

    // Constructeur qui cre la collection  vide
    public Agenda()
    {
        rdvs = new ArrayList<RendezVous>();
    }
    
    // Ajout d'un rendez-vous. Le rdv en parametre est une isntance de n'importe quelle classe
    //  qui hriterait de RendezVous
    public void ajouter(RendezVous rdv)
    {
        rdvs.add(rdv);
    }

    // Affiche tous les rdv de la collection en appelant la mthode
    //   d'affichage de chacun des objets. En fonction de sa classe d'apaprtenance
    //   chaque objet appellera la mthode afficher de sa classe.
    //  
    public void afficher()
    {
        trier();
        for(RendezVous rdv : rdvs)
            {
                System.out.println("----------------------");
                rdv.afficher();
            }
    }

    // Mthode de tri des rdv de l'agenda
    //
    public void trier()
    {
        Collections.sort(rdvs,new ComparerRdv());
    }
}



// Classe de comparaison des rendez-vous utilise pour trier
//  les rdv de l'agenda
//
class ComparerRdv implements Comparator<RendezVous>
{
    public int compare(RendezVous o1,RendezVous o2)
    {
        return( o1.getDateRdv().compareTo(o2.getDateRdv()) );
    }

}